namespace CMSMicroservice.Application.ConfigurationCQ.Queries.GetAllConfigurations;

public class GetAllConfigurationsQueryValidator : AbstractValidator<GetAllConfigurationsQuery>
{
    public GetAllConfigurationsQueryValidator()
    {
        RuleFor(x => x.Filter.Scope)
            .IsInEnum()
            .WithMessage("محدوده تنظیمات معتبر نیست")
            .When(x => x.Filter?.Scope != null);
    }

    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(
            ValidationContext<GetAllConfigurationsQuery>.CreateWithOptions(
                (GetAllConfigurationsQuery)model, 
                x => x.IncludeProperties(propertyName)));
        
        if (result.IsValid)
            return Array.Empty<string>();
        
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
